% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'matstates'}, {'array of material states'}};
            };
        val = cat(1, get(self.feblock), val);
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'matstates'
                if isempty (self.matstates)
                    integration_rule = get(self.feblock, 'integration_rule');
                    npts_per_gcell = get(integration_rule, 'npts');
                    gcells = get(self.feblock,'gcells');
                    ngcells = length(gcells);
                    self.matstates = cell(get(gcells(1),'nfens')*ngcells,npts_per_gcell);
                    mat = get(self.feblock, 'mater');
                    for i=1:ngcells
                        for j=1:npts_per_gcell;
                            self.matstates{i,j} = newmatstate(mat);
                        end
                    end
                end
                val=self.matstates;
            otherwise
                val = get(self.feblock, prop_name);
        end
    end
end
