% Scatter values to the field corresponding
% to the fen indices.
%   Call as:
%     f=scatter(f, fenids, val)
%   where
%     f=field (note that we have to assign to f: f changes inside this function)
%     fenids=array of node identifiers
%     val=an array of doubles, size(val) == [length(fenids),dim]
%
function retobj = scatter (self, fenids, val)
    [nfens,dim] = size(self.values);
    n = length(fenids);
    for i=1:n
        k = fenids(i);
        self.values(k,:) = val(i,:);
    end
    retobj = self;
    return;
end

