% Create a triangulation of the domain given as an array
% of vertex coordinates. The vertices needs to be supplied
% in counterclockwise order. Mesh size is h.
function [fens,gcells] = targe2_mesher_vl(v,h,thickness)
    n='junk';

    d=pwd;
    cd(sofea_work_path);

    fid =fopen ([n], 'w');
    nv =length(v);
    for i= 1:nv
        fprintf(fid,'curve %d line %g %g %g %g\n',i,v(i,1),v(i,2),v(mod(i,nv)+1,1),v(mod(i,nv)+1,2));
    end
    0.2
    fprintf(fid,'subregion 1  property 1 boundary ');
    for i= 1:length(v)
        fprintf(fid,'%d ',i);
    end
    fprintf(fid,'\n');
    fprintf(fid,'m-ctl-point constant %g\n',h);
    fclose (fid);

    if strncmp(computer,'PC',2)
        c=['"' sofea_path filesep 'meshes' filesep 'targe2' filesep 'Targe2.exe" -i ' n ' -o out' ];
    elseif strncmp(computer,'GLNX86',6)
        c=['"' sofea_path filesep 'meshes' filesep 'targe2' filesep 'Targe2_GLNX86" -i ' n ' -o out' ];
    else
        error(['Computer platform ' computer ' is not supported'])
    end
    system (c);

    fid =fopen (['out'], 'r');
    l=fgets(fid);% skip the name of the file
    l=fgets(fid);
    totals =sscanf(l,'%d');
    l=fgets(fid);% skip *NODES
    xy =fscanf(fid,'%g', [3,totals(1)]);
    p = xy';
    l=fgets(fid);% skip
    l=fgets(fid);% skip *TR3N
    t = zeros(totals(2),4);
    for i= 1:totals(2)
        l=fgets(fid);
        ts =sscanf(l,'%g', [1, 4]);
        t(i,:) = ts;
    end
    fclose (fid);

    nnodes= size (p, 1);
    fens(1:nnodes)=deal(fenode(struct('id',0,'xyz',[0 0])));
    ncells=size (t, 1);
    gcells(1:ncells)=deal(gcell_T3(struct('id',1,'conn',[1 2 3],'thickness',thickness)));

    for i=1: nnodes
        fens(i)=fenode(struct('id',p(i,1),'xyz',p(i,2:end)));
    end

    for i=1:ncells
        a= det ([1 p(t(i,2),2:end); 1 p(t(i,3),2:end); 1 p(t(i,4),2:end)]);
        if a>0
            gcells(i)=gcell_T3(struct ('id', t(i,1),'conn',t(i,2:end), 'thickness',thickness));
        else
            gcells(i)=gcell_T3(struct ('id', t(i,1),'conn',t(i,[1, 3, 2]+1), 'thickness',thickness));
        end
    end

    cd(d);

    % mesh{1}=fens;
    % mesh{2}=gcells;
    % drawmesh(mesh); view (2);

    return;
end
